structure Top = 
struct
  structure LPP = LambdaPlusPlus

  fun println s = print (s ^ "\n")
  fun parse_exp_and_print s =
    println (
      case LPP.parse_exp s of
        Sum.INL err => err
      | Sum.INR ast => LPP.pp_exp ast
    )
  fun parse_typ_and_print s =
    println (
      case LPP.parse_typ s of
        Sum.INL err => err
      | Sum.INR t => LPP.pp_typ t
    )

  fun check exp_string typ_string =
    println (
      case (LPP.parse_exp exp_string, LPP.parse_typ typ_string) of
        (Sum.INL err, _) => "Error parsing expression: " ^ err
      | (_, Sum.INL err) => "Error parsing type: " ^ err
      | (Sum.INR exp, Sum.INR t) =>
        Bool.toString (LPPChecker.check exp t)
    )
end